Hex Artifact Content

Artifact 82518c6710f8da8862e60cf6f5fd5172632897b6:


0000: 23 21 20 2f 75 73 72 2f 62 69 6e 2f 65 6e 76 20  #! /usr/bin/env 
0010: 62 61 73 68 0a 0a 69 66 20 5b 20 21 20 2d 66 20  bash..if [ ! -f 
0020: 27 62 75 69 6c 64 2e 73 68 27 20 5d 3b 20 74 68  'build.sh' ]; th
0030: 65 6e 0a 09 65 63 68 6f 20 27 45 52 52 4f 52 3a  en..echo 'ERROR:
0040: 20 54 68 69 73 20 73 63 72 69 70 74 20 6d 75 73   This script mus
0050: 74 20 62 65 20 72 75 6e 20 66 72 6f 6d 20 74 68  t be run from th
0060: 65 20 64 69 72 65 63 74 6f 72 79 20 69 74 20 69  e directory it i
0070: 73 20 69 6e 27 20 3e 26 32 0a 0a 09 65 78 69 74  s in' >&2...exit
0080: 20 31 0a 66 69 0a 69 66 20 5b 20 2d 7a 20 22 24   1.fi.if [ -z "$
0090: 7b 54 43 4c 56 45 52 53 7d 22 20 5d 3b 20 74 68  {TCLVERS}" ]; th
00a0: 65 6e 0a 09 65 63 68 6f 20 27 45 52 52 4f 52 3a  en..echo 'ERROR:
00b0: 20 54 68 65 20 54 43 4c 56 45 52 53 20 65 6e 76   The TCLVERS env
00c0: 69 72 6f 6e 6d 65 6e 74 20 76 61 72 69 61 62 6c  ironment variabl
00d0: 65 20 69 73 20 6e 6f 74 20 73 65 74 27 20 3e 26  e is not set' >&
00e0: 32 0a 0a 09 65 78 69 74 20 31 0a 66 69 0a 0a 54  2...exit 1.fi..T
00f0: 4c 53 56 45 52 53 3d 22 31 2e 36 2e 37 22 0a 53  LSVERS="1.6.7".S
0100: 52 43 3d 22 73 72 63 2f 74 6c 73 2d 24 7b 54 4c  RC="src/tls-${TL
0110: 53 56 45 52 53 7d 2e 74 61 72 2e 67 7a 22 0a 53  SVERS}.tar.gz".S
0120: 52 43 55 52 4c 3d 22 68 74 74 70 3a 2f 2f 73 6f  RCURL="http://so
0130: 75 72 63 65 66 6f 72 67 65 2e 6e 65 74 2f 70 72  urceforge.net/pr
0140: 6f 6a 65 63 74 73 2f 74 6c 73 2f 66 69 6c 65 73  ojects/tls/files
0150: 2f 74 6c 73 2f 24 7b 54 4c 53 56 45 52 53 7d 2f  /tls/${TLSVERS}/
0160: 74 6c 73 24 7b 54 4c 53 56 45 52 53 7d 2d 73 72  tls${TLSVERS}-sr
0170: 63 2e 74 61 72 2e 67 7a 22 0a 53 52 43 48 41 53  c.tar.gz".SRCHAS
0180: 48 3d 27 35 31 31 39 64 65 33 65 35 34 37 30 33  H='5119de3e54703
0190: 35 39 62 39 37 61 38 61 30 30 64 38 36 31 63 39  59b97a8a00d861c9
01a0: 63 34 38 34 33 33 35 37 31 65 65 30 31 36 37 61  c48433571ee0167a
01b0: 66 30 61 39 35 32 64 65 36 36 63 39 39 64 33 61  f0a952de66c99d3a
01c0: 33 62 38 27 0a 42 55 49 4c 44 44 49 52 3d 22 24  3b8'.BUILDDIR="$
01d0: 28 70 77 64 29 2f 62 75 69 6c 64 2f 74 6c 73 24  (pwd)/build/tls$
01e0: 7b 54 4c 53 56 45 52 53 7d 22 0a 4f 55 54 44 49  {TLSVERS}".OUTDI
01f0: 52 3d 22 24 28 70 77 64 29 2f 6f 75 74 22 0a 49  R="$(pwd)/out".I
0200: 4e 53 54 44 49 52 3d 22 24 28 70 77 64 29 2f 69  NSTDIR="$(pwd)/i
0210: 6e 73 74 22 0a 50 41 54 43 48 44 49 52 3d 22 24  nst".PATCHDIR="$
0220: 28 70 77 64 29 2f 70 61 74 63 68 65 73 22 0a 65  (pwd)/patches".e
0230: 78 70 6f 72 74 20 54 4c 53 56 45 52 53 20 53 52  xport TLSVERS SR
0240: 43 20 53 52 43 55 52 4c 20 42 55 49 4c 44 44 49  C SRCURL BUILDDI
0250: 52 20 4f 55 54 44 49 52 20 49 4e 53 54 44 49 52  R OUTDIR INSTDIR
0260: 20 50 41 54 43 48 44 49 52 0a 0a 23 20 53 65 74   PATCHDIR..# Set
0270: 20 63 6f 6e 66 69 67 75 72 65 20 6f 70 74 69 6f   configure optio
0280: 6e 73 20 66 6f 72 20 74 68 69 73 20 73 75 62 2d  ns for this sub-
0290: 70 72 6f 6a 65 63 74 0a 4c 44 46 4c 41 47 53 3d  project.LDFLAGS=
02a0: 22 24 7b 4c 44 46 4c 41 47 53 7d 20 24 7b 4b 43  "${LDFLAGS} ${KC
02b0: 5f 54 4c 53 5f 4c 44 46 4c 41 47 53 7d 22 0a 43  _TLS_LDFLAGS}".C
02c0: 46 4c 41 47 53 3d 22 24 7b 43 46 4c 41 47 53 7d  FLAGS="${CFLAGS}
02d0: 20 24 7b 4b 43 5f 54 4c 53 5f 43 46 4c 41 47 53   ${KC_TLS_CFLAGS
02e0: 7d 22 0a 43 50 50 46 4c 41 47 53 3d 22 24 7b 43  }".CPPFLAGS="${C
02f0: 50 50 46 4c 41 47 53 7d 20 24 7b 4b 43 5f 54 4c  PPFLAGS} ${KC_TL
0300: 53 5f 43 50 50 46 4c 41 47 53 7d 22 0a 4c 49 42  S_CPPFLAGS}".LIB
0310: 53 3d 22 24 7b 4c 49 42 53 7d 20 24 7b 4b 43 5f  S="${LIBS} ${KC_
0320: 54 4c 53 5f 4c 49 42 53 7d 22 0a 65 78 70 6f 72  TLS_LIBS}".expor
0330: 74 20 4c 44 46 4c 41 47 53 20 43 46 4c 41 47 53  t LDFLAGS CFLAGS
0340: 20 43 50 50 46 4c 41 47 53 20 4c 49 42 53 0a 0a   CPPFLAGS LIBS..
0350: 72 6d 20 2d 72 66 20 27 62 75 69 6c 64 27 20 27  rm -rf 'build' '
0360: 6f 75 74 27 20 27 69 6e 73 74 27 0a 6d 6b 64 69  out' 'inst'.mkdi
0370: 72 20 27 62 75 69 6c 64 27 20 27 6f 75 74 27 20  r 'build' 'out' 
0380: 27 69 6e 73 74 27 20 7c 7c 20 65 78 69 74 20 31  'inst' || exit 1
0390: 0a 0a 54 43 4c 5f 56 45 52 53 49 4f 4e 3d 22 75  ..TCL_VERSION="u
03a0: 6e 6b 6e 6f 77 6e 22 0a 69 66 20 5b 20 2d 66 20  nknown".if [ -f 
03b0: 22 24 7b 54 43 4c 43 4f 4e 46 49 47 44 49 52 7d  "${TCLCONFIGDIR}
03c0: 2f 74 63 6c 43 6f 6e 66 69 67 2e 73 68 22 20 5d  /tclConfig.sh" ]
03d0: 3b 20 74 68 65 6e 0a 20 20 20 20 20 20 20 20 73  ; then.        s
03e0: 6f 75 72 63 65 20 22 24 7b 54 43 4c 43 4f 4e 46  ource "${TCLCONF
03f0: 49 47 44 49 52 7d 2f 74 63 6c 43 6f 6e 66 69 67  IGDIR}/tclConfig
0400: 2e 73 68 22 0a 66 69 0a 65 78 70 6f 72 74 20 54  .sh".fi.export T
0410: 43 4c 5f 56 45 52 53 49 4f 4e 0a 0a 69 66 20 5b  CL_VERSION..if [
0420: 20 21 20 2d 66 20 22 24 7b 53 52 43 7d 22 20 5d   ! -f "${SRC}" ]
0430: 3b 20 74 68 65 6e 0a 09 6d 6b 64 69 72 20 27 73  ; then..mkdir 's
0440: 72 63 27 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20 32  rc' >/dev/null 2
0450: 3e 2f 64 65 76 2f 6e 75 6c 6c 0a 0a 09 69 66 20  >/dev/null...if 
0460: 5b 20 21 20 2d 64 20 27 62 75 69 6c 64 73 72 63  [ ! -d 'buildsrc
0470: 27 20 5d 3b 20 74 68 65 6e 0a 09 09 64 6f 77 6e  ' ]; then...down
0480: 6c 6f 61 64 20 22 24 7b 53 52 43 55 52 4c 7d 22  load "${SRCURL}"
0490: 20 22 24 7b 53 52 43 7d 22 20 22 24 7b 53 52 43   "${SRC}" "${SRC
04a0: 48 41 53 48 7d 22 20 7c 7c 20 65 78 69 74 20 31  HASH}" || exit 1
04b0: 0a 09 66 69 0a 66 69 0a 0a 66 75 6e 63 74 69 6f  ..fi.fi..functio
04c0: 6e 20 62 75 69 6c 64 53 53 4c 4c 69 62 72 61 72  n buildSSLLibrar
04d0: 79 28 29 20 7b 0a 09 6c 6f 63 61 6c 20 76 65 72  y() {..local ver
04e0: 73 69 6f 6e 20 75 72 6c 20 68 61 73 68 0a 09 6c  sion url hash..l
04f0: 6f 63 61 6c 20 61 72 63 68 69 76 65 0a 0a 09 76  ocal archive...v
0500: 65 72 73 69 6f 6e 3d 27 32 2e 34 2e 31 27 0a 09  ersion='2.4.1'..
0510: 75 72 6c 3d 22 68 74 74 70 3a 2f 2f 66 74 70 2e  url="http://ftp.
0520: 6f 70 65 6e 62 73 64 2e 6f 72 67 2f 70 75 62 2f  openbsd.org/pub/
0530: 4f 70 65 6e 42 53 44 2f 4c 69 62 72 65 53 53 4c  OpenBSD/LibreSSL
0540: 2f 6c 69 62 72 65 73 73 6c 2d 24 7b 76 65 72 73  /libressl-${vers
0550: 69 6f 6e 7d 2e 74 61 72 2e 67 7a 22 0a 09 68 61  ion}.tar.gz"..ha
0560: 73 68 3d 27 31 32 31 39 32 32 62 31 33 31 36 39  sh='121922b13169
0570: 63 64 34 37 61 38 35 65 33 65 37 37 66 30 62 63  cd47a85e3e77f0bc
0580: 31 32 39 66 38 64 30 34 32 34 37 31 39 33 62 34  129f8d04247193b4
0590: 32 34 39 31 63 62 31 66 61 62 39 30 37 34 65 38  2491cb1fab9074e8
05a0: 30 34 37 37 27 0a 0a 09 61 72 63 68 69 76 65 3d  0477'...archive=
05b0: 22 73 72 63 2f 6c 69 62 72 65 73 73 6c 2d 24 7b  "src/libressl-${
05c0: 76 65 72 73 69 6f 6e 7d 2e 74 61 72 2e 67 7a 22  version}.tar.gz"
05d0: 0a 0a 09 65 63 68 6f 20 22 20 2a 2a 2a 20 42 75  ...echo " *** Bu
05e0: 69 6c 64 69 6e 67 20 4c 69 62 72 65 53 53 4c 20  ilding LibreSSL 
05f0: 76 24 7b 76 65 72 73 69 6f 6e 7d 22 20 3e 26 32  v${version}" >&2
0600: 0a 0a 09 69 66 20 5b 20 21 20 2d 65 20 22 2e 2e  ...if [ ! -e "..
0610: 2f 24 7b 61 72 63 68 69 76 65 7d 22 20 5d 3b 20  /${archive}" ]; 
0620: 74 68 65 6e 0a 09 09 64 6f 77 6e 6c 6f 61 64 20  then...download 
0630: 22 24 7b 75 72 6c 7d 22 20 22 2e 2e 2f 24 7b 61  "${url}" "../${a
0640: 72 63 68 69 76 65 7d 22 20 22 24 7b 68 61 73 68  rchive}" "${hash
0650: 7d 22 20 7c 7c 20 72 65 74 75 72 6e 20 31 0a 09  }" || return 1..
0660: 66 69 0a 0a 09 28 0a 09 09 72 6d 20 2d 72 66 20  fi...(...rm -rf 
0670: 6c 69 62 72 65 73 73 6c 2d 2a 0a 0a 09 09 67 7a  libressl-*....gz
0680: 69 70 20 2d 64 63 20 22 2e 2e 2f 24 7b 61 72 63  ip -dc "../${arc
0690: 68 69 76 65 7d 22 20 7c 20 74 61 72 20 2d 78 66  hive}" | tar -xf
06a0: 20 2d 20 7c 7c 20 65 78 69 74 20 31 0a 0a 09 09   - || exit 1....
06b0: 63 64 20 22 6c 69 62 72 65 73 73 6c 2d 24 7b 76  cd "libressl-${v
06c0: 65 72 73 69 6f 6e 7d 22 20 7c 7c 20 65 78 69 74  ersion}" || exit
06d0: 20 31 0a 0a 09 09 65 63 68 6f 20 22 52 75 6e 6e   1....echo "Runn
06e0: 69 6e 67 3a 20 2e 2f 63 6f 6e 66 69 67 75 72 65  ing: ./configure
06f0: 20 24 7b 43 4f 4e 46 49 47 55 52 45 45 58 54 52   ${CONFIGUREEXTR
0700: 41 7d 20 2d 2d 64 69 73 61 62 6c 65 2d 73 68 61  A} --disable-sha
0710: 72 65 64 20 2d 2d 65 6e 61 62 6c 65 2d 73 74 61  red --enable-sta
0720: 74 69 63 20 2d 2d 70 72 65 66 69 78 3d 5c 22 24  tic --prefix=\"$
0730: 28 70 77 64 29 2f 49 4e 53 54 5c 22 22 0a 09 09  (pwd)/INST\""...
0740: 2e 2f 63 6f 6e 66 69 67 75 72 65 20 24 7b 43 4f  ./configure ${CO
0750: 4e 46 49 47 55 52 45 45 58 54 52 41 7d 20 2d 2d  NFIGUREEXTRA} --
0760: 64 69 73 61 62 6c 65 2d 73 68 61 72 65 64 20 2d  disable-shared -
0770: 2d 65 6e 61 62 6c 65 2d 73 74 61 74 69 63 20 2d  -enable-static -
0780: 2d 70 72 65 66 69 78 3d 22 24 28 70 77 64 29 2f  -prefix="$(pwd)/
0790: 49 4e 53 54 22 20 7c 7c 20 65 78 69 74 20 31 0a  INST" || exit 1.
07a0: 0a 09 09 65 63 68 6f 20 22 52 75 6e 6e 69 6e 67  ...echo "Running
07b0: 3a 20 24 7b 4d 41 4b 45 3a 2d 6d 61 6b 65 7d 20  : ${MAKE:-make} 
07c0: 56 3d 31 22 0a 09 09 24 7b 4d 41 4b 45 3a 2d 6d  V=1"...${MAKE:-m
07d0: 61 6b 65 7d 20 56 3d 31 20 7c 7c 20 65 78 69 74  ake} V=1 || exit
07e0: 20 31 0a 0a 09 09 65 63 68 6f 20 22 52 75 6e 6e   1....echo "Runn
07f0: 69 6e 67 3a 20 24 7b 4d 41 4b 45 3a 2d 6d 61 6b  ing: ${MAKE:-mak
0800: 65 7d 20 56 3d 31 20 69 6e 73 74 61 6c 6c 22 20  e} V=1 install" 
0810: 0a 09 09 24 7b 4d 41 4b 45 3a 2d 6d 61 6b 65 7d  ...${MAKE:-make}
0820: 20 56 3d 31 20 69 6e 73 74 61 6c 6c 20 7c 7c 20   V=1 install || 
0830: 65 78 69 74 20 31 0a 09 29 20 7c 7c 20 72 65 74  exit 1..) || ret
0840: 75 72 6e 20 31 0a 0a 09 53 53 4c 44 49 52 3d 22  urn 1...SSLDIR="
0850: 24 28 70 77 64 29 2f 6c 69 62 72 65 73 73 6c 2d  $(pwd)/libressl-
0860: 24 7b 76 65 72 73 69 6f 6e 7d 2f 49 4e 53 54 22  ${version}/INST"
0870: 0a 09 61 64 64 6c 69 62 73 3d 22 24 28 50 4b 47  ..addlibs="$(PKG
0880: 5f 43 4f 4e 46 49 47 5f 50 41 54 48 3d 22 24 28  _CONFIG_PATH="$(
0890: 70 77 64 29 2f 6c 69 62 72 65 73 73 6c 2d 24 7b  pwd)/libressl-${
08a0: 76 65 72 73 69 6f 6e 7d 2f 49 4e 53 54 2f 6c 69  version}/INST/li
08b0: 62 2f 70 6b 67 63 6f 6e 66 69 67 22 20 22 24 7b  b/pkgconfig" "${
08c0: 50 4b 47 5f 43 4f 4e 46 49 47 3a 2d 70 6b 67 2d  PKG_CONFIG:-pkg-
08d0: 63 6f 6e 66 69 67 7d 22 20 6c 69 62 73 73 6c 20  config}" libssl 
08e0: 6c 69 62 63 72 79 70 74 6f 20 2d 2d 6c 69 62 73  libcrypto --libs
08f0: 20 2d 2d 73 74 61 74 69 63 29 22 0a 7d 0a 0a 28   --static)".}..(
0900: 0a 09 63 64 20 27 62 75 69 6c 64 27 20 7c 7c 20  ..cd 'build' || 
0910: 65 78 69 74 20 31 0a 0a 09 69 66 20 5b 20 21 20  exit 1...if [ ! 
0920: 2d 64 20 27 2e 2e 2f 62 75 69 6c 64 73 72 63 27  -d '../buildsrc'
0930: 20 5d 3b 20 74 68 65 6e 0a 09 09 67 7a 69 70 20   ]; then...gzip 
0940: 2d 64 63 20 22 2e 2e 2f 24 7b 53 52 43 7d 22 20  -dc "../${SRC}" 
0950: 7c 20 74 61 72 20 2d 78 66 20 2d 0a 09 65 6c 73  | tar -xf -..els
0960: 65 20 20 20 20 0a 09 09 63 70 20 2d 72 70 20 2e  e    ...cp -rp .
0970: 2e 2f 62 75 69 6c 64 73 72 63 2f 2a 20 27 2e 2f  ./buildsrc/* './
0980: 27 0a 09 66 69 0a 0a 09 23 20 44 65 74 65 72 6d  '..fi...# Determ
0990: 69 6e 65 20 53 53 4c 20 64 69 72 65 63 74 6f 72  ine SSL director
09a0: 79 0a 09 69 66 20 5b 20 2d 7a 20 22 24 7b 43 50  y..if [ -z "${CP
09b0: 50 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 09 43 50  P}" ]; then...CP
09c0: 50 3d 22 24 7b 43 43 3a 2d 63 63 7d 20 2d 45 22  P="${CC:-cc} -E"
09d0: 0a 09 66 69 0a 0a 09 69 66 20 5b 20 2d 6e 20 22  ..fi...if [ -n "
09e0: 24 7b 4b 43 5f 54 4c 53 5f 53 53 4c 44 49 52 7d  ${KC_TLS_SSLDIR}
09f0: 22 20 5d 3b 20 74 68 65 6e 0a 09 09 53 53 4c 44  " ]; then...SSLD
0a00: 49 52 3d 22 24 7b 4b 43 5f 54 4c 53 5f 53 53 4c  IR="${KC_TLS_SSL
0a10: 44 49 52 7d 22 0a 09 65 6c 73 65 0a 09 09 53 53  DIR}"..else...SS
0a20: 4c 44 49 52 3d 27 27 0a 0a 09 09 69 66 20 5b 20  LDIR=''....if [ 
0a30: 2d 7a 20 22 24 7b 4b 43 5f 54 4c 53 5f 42 55 49  -z "${KC_TLS_BUI
0a40: 4c 44 53 53 4c 7d 22 20 5d 3b 20 74 68 65 6e 0a  LDSSL}" ]; then.
0a50: 09 09 09 53 53 4c 44 49 52 3d 22 24 28 65 63 68  ...SSLDIR="$(ech
0a60: 6f 20 27 23 69 6e 63 6c 75 64 65 20 3c 6f 70 65  o '#include <ope
0a70: 6e 73 73 6c 2f 73 73 6c 2e 68 3e 27 20 32 3e 2f  nssl/ssl.h>' 2>/
0a80: 64 65 76 2f 6e 75 6c 6c 20 7c 20 24 7b 43 50 50  dev/null | ${CPP
0a90: 7d 20 2d 20 32 3e 20 2f 64 65 76 2f 6e 75 6c 6c  } - 2> /dev/null
0aa0: 20 7c 20 61 77 6b 20 27 2f 23 20 31 20 22 5c 2f   | awk '/# 1 "\/
0ab0: 2e 2a 5c 2f 73 73 6c 5c 2e 68 2f 7b 20 70 72 69  .*\/ssl\.h/{ pri
0ac0: 6e 74 20 24 33 3b 20 65 78 69 74 20 7d 27 20 7c  nt $3; exit }' |
0ad0: 20 73 65 64 20 27 73 40 5e 22 40 40 3b 73 40 22   sed 's@^"@@;s@"
0ae0: 24 40 40 3b 73 40 2f 69 6e 63 6c 75 64 65 2f 6f  $@@;s@/include/o
0af0: 70 65 6e 73 73 6c 2f 73 73 6c 5c 2e 68 24 40 40  penssl/ssl\.h$@@
0b00: 27 29 22 0a 09 09 66 69 0a 0a 09 09 69 66 20 5b  ')"...fi....if [
0b10: 20 2d 7a 20 22 24 7b 53 53 4c 44 49 52 7d 22 20   -z "${SSLDIR}" 
0b20: 5d 3b 20 74 68 65 6e 0a 09 09 09 62 75 69 6c 64  ]; then....build
0b30: 53 53 4c 4c 69 62 72 61 72 79 20 7c 7c 20 53 53  SSLLibrary || SS
0b40: 4c 44 49 52 3d 27 27 0a 09 09 66 69 0a 0a 09 09  LDIR=''...fi....
0b50: 69 66 20 5b 20 2d 7a 20 22 24 7b 53 53 4c 44 49  if [ -z "${SSLDI
0b60: 52 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 09 09 65  R}" ]; then....e
0b70: 63 68 6f 20 22 55 6e 61 62 6c 65 20 74 6f 20 66  cho "Unable to f
0b80: 69 6e 64 20 4f 70 65 6e 53 53 4c 2c 20 61 62 6f  ind OpenSSL, abo
0b90: 72 74 69 6e 67 2e 22 20 3e 26 32 0a 0a 09 09 09  rting." >&2.....
0ba0: 65 78 69 74 20 31 0a 09 09 66 69 0a 09 66 69 0a  exit 1...fi..fi.
0bb0: 0a 09 23 20 41 70 70 6c 79 20 72 65 71 75 69 72  ..# Apply requir
0bc0: 65 64 20 70 61 74 63 68 65 73 0a 09 63 64 20 22  ed patches..cd "
0bd0: 24 7b 42 55 49 4c 44 44 49 52 7d 22 20 7c 7c 20  ${BUILDDIR}" || 
0be0: 65 78 69 74 20 31 0a 09 66 6f 72 20 70 61 74 63  exit 1..for patc
0bf0: 68 20 69 6e 20 22 24 7b 50 41 54 43 48 44 49 52  h in "${PATCHDIR
0c00: 7d 2f 61 6c 6c 22 2f 74 6c 73 2d 24 7b 54 4c 53  }/all"/tls-${TLS
0c10: 56 45 52 53 7d 2d 2a 2e 64 69 66 66 20 22 24 7b  VERS}-*.diff "${
0c20: 50 41 54 43 48 44 49 52 7d 2f 24 7b 54 43 4c 5f  PATCHDIR}/${TCL_
0c30: 56 45 52 53 49 4f 4e 7d 22 2f 74 6c 73 2d 24 7b  VERSION}"/tls-${
0c40: 54 4c 53 56 45 52 53 7d 2d 2a 2e 64 69 66 66 3b  TLSVERS}-*.diff;
0c50: 20 64 6f 0a 09 09 69 66 20 5b 20 21 20 2d 66 20   do...if [ ! -f 
0c60: 22 24 7b 70 61 74 63 68 7d 22 20 5d 3b 20 74 68  "${patch}" ]; th
0c70: 65 6e 0a 09 09 09 63 6f 6e 74 69 6e 75 65 0a 09  en....continue..
0c80: 09 66 69 0a 0a 09 09 65 63 68 6f 20 22 41 70 70  .fi....echo "App
0c90: 6c 79 69 6e 67 3a 20 24 7b 70 61 74 63 68 7d 22  lying: ${patch}"
0ca0: 0a 09 09 24 7b 50 41 54 43 48 3a 2d 70 61 74 63  ...${PATCH:-patc
0cb0: 68 7d 20 2d 70 31 20 3c 20 22 24 7b 70 61 74 63  h} -p1 < "${patc
0cc0: 68 7d 22 0a 09 64 6f 6e 65 0a 0a 09 63 64 20 22  h}"..done...cd "
0cd0: 24 7b 42 55 49 4c 44 44 49 52 7d 22 20 7c 7c 20  ${BUILDDIR}" || 
0ce0: 65 78 69 74 20 31 0a 0a 09 23 20 54 72 79 20 74  exit 1...# Try t
0cf0: 6f 20 62 75 69 6c 64 20 61 73 20 61 20 73 68 61  o build as a sha
0d00: 72 65 64 20 6f 62 6a 65 63 74 20 69 66 20 72 65  red object if re
0d10: 71 75 65 73 74 65 64 0a 09 69 66 20 5b 20 22 24  quested..if [ "$
0d20: 7b 53 54 41 54 49 43 54 4c 53 7d 22 20 3d 20 22  {STATICTLS}" = "
0d30: 30 22 20 5d 3b 20 74 68 65 6e 0a 09 09 74 72 79  0" ]; then...try
0d40: 6f 70 74 73 3d 22 2d 2d 65 6e 61 62 6c 65 2d 73  opts="--enable-s
0d50: 68 61 72 65 64 20 2d 2d 64 69 73 61 62 6c 65 2d  hared --disable-
0d60: 73 68 61 72 65 64 22 0a 09 65 6c 69 66 20 5b 20  shared"..elif [ 
0d70: 22 24 7b 53 54 41 54 49 43 54 4c 53 7d 22 20 3d  "${STATICTLS}" =
0d80: 20 22 2d 31 22 20 5d 3b 20 74 68 65 6e 0a 09 09   "-1" ]; then...
0d90: 74 72 79 6f 70 74 73 3d 22 2d 2d 65 6e 61 62 6c  tryopts="--enabl
0da0: 65 2d 73 68 61 72 65 64 22 0a 09 65 6c 73 65 0a  e-shared"..else.
0db0: 09 09 74 72 79 6f 70 74 73 3d 22 2d 2d 64 69 73  ..tryopts="--dis
0dc0: 61 62 6c 65 2d 73 68 61 72 65 64 22 0a 09 66 69  able-shared"..fi
0dd0: 0a 0a 09 23 20 44 69 73 61 62 6c 65 20 53 53 4c  ...# Disable SSL
0de0: 76 32 2c 20 6e 65 77 65 72 20 53 53 4c 20 6c 69  v2, newer SSL li
0df0: 62 72 61 72 69 65 73 20 64 72 6f 70 20 73 75 70  braries drop sup
0e00: 70 6f 72 74 20 66 6f 72 20 69 74 20 65 6e 74 69  port for it enti
0e10: 72 65 6c 79 0a 09 43 46 4c 41 47 53 3d 22 24 7b  rely..CFLAGS="${
0e20: 43 46 4c 41 47 53 7d 20 2d 44 4e 4f 5f 53 53 4c  CFLAGS} -DNO_SSL
0e30: 32 3d 31 22 0a 0a 09 23 20 44 69 73 61 62 6c 65  2=1"...# Disable
0e40: 20 53 53 4c 76 33 2c 20 6e 65 77 65 72 20 53 53   SSLv3, newer SS
0e50: 4c 20 6c 69 62 72 61 72 69 65 73 20 64 72 6f 70  L libraries drop
0e60: 20 73 75 70 70 6f 72 74 20 66 6f 72 20 69 74 20   support for it 
0e70: 65 6e 74 69 72 65 6c 79 0a 09 43 46 4c 41 47 53  entirely..CFLAGS
0e80: 3d 22 24 7b 43 46 4c 41 47 53 7d 20 2d 44 4e 4f  ="${CFLAGS} -DNO
0e90: 5f 53 53 4c 33 3d 31 22 0a 0a 09 53 41 56 45 5f  _SSL3=1"...SAVE_
0ea0: 43 46 4c 41 47 53 3d 22 24 7b 43 46 4c 41 47 53  CFLAGS="${CFLAGS
0eb0: 7d 22 0a 09 53 41 56 45 5f 4c 49 42 53 3d 22 24  }"..SAVE_LIBS="$
0ec0: 7b 4c 49 42 53 7d 22 0a 09 66 6f 72 20 74 72 79  {LIBS}"..for try
0ed0: 6f 70 74 20 69 6e 20 24 74 72 79 6f 70 74 73 20  opt in $tryopts 
0ee0: 5f 5f 66 61 69 6c 5f 5f 3b 20 64 6f 0a 09 09 43  __fail__; do...C
0ef0: 46 4c 41 47 53 3d 22 24 7b 53 41 56 45 5f 43 46  FLAGS="${SAVE_CF
0f00: 4c 41 47 53 7d 22 0a 09 09 4c 49 42 53 3d 22 24  LAGS}"...LIBS="$
0f10: 7b 53 41 56 45 5f 4c 49 42 53 7d 22 0a 09 09 65  {SAVE_LIBS}"...e
0f20: 78 70 6f 72 74 20 43 46 4c 41 47 53 20 4c 49 42  xport CFLAGS LIB
0f30: 53 0a 0a 09 09 23 20 43 6c 65 61 6e 20 75 70 2c  S....# Clean up,
0f40: 20 69 66 20 6e 65 65 64 65 64 0a 09 09 6d 61 6b   if needed...mak
0f50: 65 20 64 69 73 74 63 6c 65 61 6e 20 3e 2f 64 65  e distclean >/de
0f60: 76 2f 6e 75 6c 6c 20 32 3e 2f 64 65 76 2f 6e 75  v/null 2>/dev/nu
0f70: 6c 6c 0a 09 09 72 6d 20 2d 72 66 20 22 24 7b 49  ll...rm -rf "${I
0f80: 4e 53 54 44 49 52 7d 22 0a 09 09 6d 6b 64 69 72  NSTDIR}"...mkdir
0f90: 20 22 24 7b 49 4e 53 54 44 49 52 7d 22 0a 0a 09   "${INSTDIR}"...
0fa0: 09 69 66 20 5b 20 22 24 7b 74 72 79 6f 70 74 7d  .if [ "${tryopt}
0fb0: 22 20 3d 20 22 5f 5f 66 61 69 6c 5f 5f 22 20 5d  " = "__fail__" ]
0fc0: 3b 20 74 68 65 6e 0a 09 09 09 65 78 69 74 20 31  ; then....exit 1
0fd0: 0a 09 09 66 69 0a 0a 09 09 69 66 20 5b 20 22 24  ...fi....if [ "$
0fe0: 7b 74 72 79 6f 70 74 7d 22 20 3d 3d 20 22 2d 2d  {tryopt}" == "--
0ff0: 65 6e 61 62 6c 65 2d 73 68 61 72 65 64 22 20 5d  enable-shared" ]
1000: 3b 20 74 68 65 6e 0a 09 09 09 69 73 73 68 61 72  ; then....isshar
1010: 65 64 3d 22 31 22 0a 09 09 65 6c 73 65 0a 09 09  ed="1"...else...
1020: 09 69 73 73 68 61 72 65 64 3d 22 30 22 0a 09 09  .isshared="0"...
1030: 66 69 0a 0a 09 09 23 20 49 66 20 62 75 69 6c 64  fi....# If build
1040: 69 6e 67 20 61 20 73 68 61 72 65 64 20 54 4c 53  ing a shared TLS
1050: 2c 20 61 64 64 20 74 68 65 20 4c 49 4e 4b 41 44  , add the LINKAD
1060: 44 20 6c 69 62 72 61 72 69 65 73 20 68 65 72 65  D libraries here
1070: 0a 09 09 69 66 20 5b 20 22 24 7b 69 73 73 68 61  ...if [ "${issha
1080: 72 65 64 7d 22 20 3d 20 27 31 27 20 5d 3b 20 74  red}" = '1' ]; t
1090: 68 65 6e 0a 09 09 09 4c 49 42 53 3d 22 24 7b 4c  hen....LIBS="${L
10a0: 49 42 53 7d 20 24 7b 4b 43 5f 54 4c 53 5f 4c 49  IBS} ${KC_TLS_LI
10b0: 4e 4b 41 44 44 7d 22 0a 09 09 66 69 0a 0a 09 09  NKADD}"...fi....
10c0: 23 20 49 66 20 62 75 69 6c 64 20 61 20 73 74 61  # If build a sta
10d0: 74 69 63 20 54 4c 53 20 66 6f 72 20 4b 69 74 44  tic TLS for KitD
10e0: 4c 4c 2c 20 65 6e 73 75 72 65 20 74 68 61 74 20  LL, ensure that 
10f0: 77 65 20 75 73 65 20 50 49 43 0a 09 09 23 20 73  we use PIC...# s
1100: 6f 20 74 68 61 74 20 69 74 20 63 61 6e 20 62 65  o that it can be
1110: 20 6c 69 6e 6b 65 64 20 69 6e 74 6f 20 74 68 65   linked into the
1120: 20 73 68 61 72 65 64 20 6f 62 6a 65 63 74 0a 09   shared object..
1130: 09 69 66 20 5b 20 22 24 7b 69 73 73 68 61 72 65  .if [ "${isshare
1140: 64 7d 22 20 3d 20 22 30 22 20 2d 61 20 22 24 7b  d}" = "0" -a "${
1150: 4b 49 54 54 41 52 47 45 54 7d 22 20 3d 20 22 6b  KITTARGET}" = "k
1160: 69 74 64 6c 6c 22 20 5d 3b 20 74 68 65 6e 0a 09  itdll" ]; then..
1170: 09 09 43 46 4c 41 47 53 3d 22 24 7b 43 46 4c 41  ..CFLAGS="${CFLA
1180: 47 53 7d 20 2d 66 50 49 43 22 0a 09 09 66 69 0a  GS} -fPIC"...fi.
1190: 0a 09 09 69 66 20 5b 20 22 24 7b 69 73 73 68 61  ...if [ "${issha
11a0: 72 65 64 7d 22 20 3d 20 27 30 27 20 5d 3b 20 74  red}" = '0' ]; t
11b0: 68 65 6e 0a 09 09 09 73 65 64 20 27 73 40 55 53  hen....sed 's@US
11c0: 45 5f 54 43 4c 5f 53 54 55 42 53 40 58 58 58 5f  E_TCL_STUBS@XXX_
11d0: 54 43 4c 5f 53 54 55 42 53 40 67 27 20 63 6f 6e  TCL_STUBS@g' con
11e0: 66 69 67 75 72 65 20 3e 20 63 6f 6e 66 69 67 75  figure > configu
11f0: 72 65 2e 6e 65 77 0a 09 09 65 6c 73 65 0a 09 09  re.new...else...
1200: 09 73 65 64 20 27 73 40 58 58 58 5f 54 43 4c 5f  .sed 's@XXX_TCL_
1210: 53 54 55 42 53 40 55 53 45 5f 54 43 4c 5f 53 54  STUBS@USE_TCL_ST
1220: 55 42 53 40 67 27 20 63 6f 6e 66 69 67 75 72 65  UBS@g' configure
1230: 20 3e 20 63 6f 6e 66 69 67 75 72 65 2e 6e 65 77   > configure.new
1240: 0a 09 09 66 69 0a 09 09 63 61 74 20 63 6f 6e 66  ...fi...cat conf
1250: 69 67 75 72 65 2e 6e 65 77 20 3e 20 63 6f 6e 66  igure.new > conf
1260: 69 67 75 72 65 0a 09 09 72 6d 20 2d 66 20 63 6f  igure...rm -f co
1270: 6e 66 69 67 75 72 65 2e 6e 65 77 0a 0a 09 09 28  nfigure.new....(
1280: 0a 09 09 09 65 63 68 6f 20 22 52 75 6e 6e 69 6e  ....echo "Runnin
1290: 67 3a 20 2e 2f 63 6f 6e 66 69 67 75 72 65 20 24  g: ./configure $
12a0: 74 72 79 6f 70 74 20 2d 2d 70 72 65 66 69 78 3d  tryopt --prefix=
12b0: 5c 22 24 7b 49 4e 53 54 44 49 52 7d 5c 22 20 2d  \"${INSTDIR}\" -
12c0: 2d 65 78 65 63 2d 70 72 65 66 69 78 3d 5c 22 24  -exec-prefix=\"$
12d0: 7b 49 4e 53 54 44 49 52 7d 5c 22 20 2d 2d 6c 69  {INSTDIR}\" --li
12e0: 62 64 69 72 3d 5c 22 24 7b 49 4e 53 54 44 49 52  bdir=\"${INSTDIR
12f0: 7d 2f 6c 69 62 5c 22 20 2d 2d 77 69 74 68 2d 74  }/lib\" --with-t
1300: 63 6c 3d 5c 22 24 7b 54 43 4c 43 4f 4e 46 49 47  cl=\"${TCLCONFIG
1310: 44 49 52 7d 5c 22 20 2d 2d 77 69 74 68 2d 73 73  DIR}\" --with-ss
1320: 6c 2d 64 69 72 3d 5c 22 24 7b 53 53 4c 44 49 52  l-dir=\"${SSLDIR
1330: 7d 5c 22 20 24 7b 43 4f 4e 46 49 47 55 52 45 45  }\" ${CONFIGUREE
1340: 58 54 52 41 7d 22 0a 09 09 09 2e 2f 63 6f 6e 66  XTRA}"...../conf
1350: 69 67 75 72 65 20 24 74 72 79 6f 70 74 20 2d 2d  igure $tryopt --
1360: 70 72 65 66 69 78 3d 22 24 7b 49 4e 53 54 44 49  prefix="${INSTDI
1370: 52 7d 22 20 2d 2d 65 78 65 63 2d 70 72 65 66 69  R}" --exec-prefi
1380: 78 3d 22 24 7b 49 4e 53 54 44 49 52 7d 22 20 2d  x="${INSTDIR}" -
1390: 2d 6c 69 62 64 69 72 3d 22 24 7b 49 4e 53 54 44  -libdir="${INSTD
13a0: 49 52 7d 2f 6c 69 62 22 20 2d 2d 77 69 74 68 2d  IR}/lib" --with-
13b0: 74 63 6c 3d 22 24 7b 54 43 4c 43 4f 4e 46 49 47  tcl="${TCLCONFIG
13c0: 44 49 52 7d 22 20 2d 2d 77 69 74 68 2d 73 73 6c  DIR}" --with-ssl
13d0: 2d 64 69 72 3d 22 24 7b 53 53 4c 44 49 52 7d 22  -dir="${SSLDIR}"
13e0: 20 24 7b 43 4f 4e 46 49 47 55 52 45 45 58 54 52   ${CONFIGUREEXTR
13f0: 41 7d 0a 0a 09 09 09 65 63 68 6f 20 22 52 75 6e  A}.....echo "Run
1400: 6e 69 6e 67 3a 20 24 7b 4d 41 4b 45 3a 2d 6d 61  ning: ${MAKE:-ma
1410: 6b 65 7d 20 74 63 6c 6c 69 62 64 69 72 3d 5c 22  ke} tcllibdir=\"
1420: 24 7b 49 4e 53 54 44 49 52 7d 2f 6c 69 62 5c 22  ${INSTDIR}/lib\"
1430: 20 41 52 3d 5c 22 24 7b 41 52 3a 2d 61 72 7d 5c   AR=\"${AR:-ar}\
1440: 22 20 52 41 4e 4c 49 42 3d 5c 22 24 7b 52 41 4e  " RANLIB=\"${RAN
1450: 4c 49 42 3a 2d 72 61 6e 6c 69 62 7d 5c 22 22 0a  LIB:-ranlib}\"".
1460: 09 09 09 24 7b 4d 41 4b 45 3a 2d 6d 61 6b 65 7d  ...${MAKE:-make}
1470: 20 74 63 6c 6c 69 62 64 69 72 3d 22 24 7b 49 4e   tcllibdir="${IN
1480: 53 54 44 49 52 7d 2f 6c 69 62 22 20 41 52 3d 22  STDIR}/lib" AR="
1490: 24 7b 41 52 3a 2d 61 72 7d 22 20 52 41 4e 4c 49  ${AR:-ar}" RANLI
14a0: 42 3d 22 24 7b 52 41 4e 4c 49 42 3a 2d 72 61 6e  B="${RANLIB:-ran
14b0: 6c 69 62 7d 22 20 7c 7c 20 65 78 69 74 20 31 0a  lib}" || exit 1.
14c0: 0a 09 09 09 65 63 68 6f 20 22 52 75 6e 6e 69 6e  ....echo "Runnin
14d0: 67 3a 20 24 7b 4d 41 4b 45 3a 2d 6d 61 6b 65 7d  g: ${MAKE:-make}
14e0: 20 74 63 6c 6c 69 62 64 69 72 3d 5c 22 24 7b 49   tcllibdir=\"${I
14f0: 4e 53 54 44 49 52 7d 2f 6c 69 62 5c 22 20 41 52  NSTDIR}/lib\" AR
1500: 3d 5c 22 24 7b 41 52 3a 2d 61 72 7d 5c 22 20 52  =\"${AR:-ar}\" R
1510: 41 4e 4c 49 42 3d 5c 22 24 7b 52 41 4e 4c 49 42  ANLIB=\"${RANLIB
1520: 3a 2d 72 61 6e 6c 69 62 7d 5c 22 20 69 6e 73 74  :-ranlib}\" inst
1530: 61 6c 6c 22 0a 09 09 09 24 7b 4d 41 4b 45 3a 2d  all"....${MAKE:-
1540: 6d 61 6b 65 7d 20 74 63 6c 6c 69 62 64 69 72 3d  make} tcllibdir=
1550: 22 24 7b 49 4e 53 54 44 49 52 7d 2f 6c 69 62 22  "${INSTDIR}/lib"
1560: 20 41 52 3d 22 24 7b 41 52 3a 2d 61 72 7d 22 20   AR="${AR:-ar}" 
1570: 52 41 4e 4c 49 42 3d 22 24 7b 52 41 4e 4c 49 42  RANLIB="${RANLIB
1580: 3a 2d 72 61 6e 6c 69 62 7d 22 20 69 6e 73 74 61  :-ranlib}" insta
1590: 6c 6c 20 7c 7c 20 65 78 69 74 20 31 0a 09 09 29  ll || exit 1...)
15a0: 20 7c 7c 20 63 6f 6e 74 69 6e 75 65 0a 0a 09 09   || continue....
15b0: 23 20 44 65 74 65 72 6d 69 6e 65 20 53 53 4c 20  # Determine SSL 
15c0: 6c 69 62 72 61 72 79 20 64 69 72 65 63 74 6f 72  library director
15d0: 79 0a 09 09 53 53 4c 5f 4c 49 42 5f 44 49 52 3d  y...SSL_LIB_DIR=
15e0: 22 24 28 24 7b 4d 41 4b 45 3a 2d 6d 61 6b 65 7d  "$(${MAKE:-make}
15f0: 20 2d 2d 70 72 69 6e 74 2d 64 61 74 61 2d 62 61   --print-data-ba
1600: 73 65 20 7c 20 61 77 6b 20 27 2f 5e 53 53 4c 5f  se | awk '/^SSL_
1610: 4c 49 42 5f 44 49 52 20 3d 20 2f 7b 20 70 72 69  LIB_DIR = /{ pri
1620: 6e 74 20 7d 27 20 7c 20 73 65 64 20 27 73 40 5e  nt }' | sed 's@^
1630: 53 53 4c 5f 4c 49 42 5f 44 49 52 20 3d 20 2a 40  SSL_LIB_DIR = *@
1640: 40 27 29 22 0a 0a 09 09 65 63 68 6f 20 22 53 53  @')"....echo "SS
1650: 4c 5f 4c 49 42 5f 44 49 52 20 3d 20 24 7b 53 53  L_LIB_DIR = ${SS
1660: 4c 5f 4c 49 42 5f 44 49 52 7d 22 0a 0a 09 09 62  L_LIB_DIR}"....b
1670: 72 65 61 6b 0a 09 64 6f 6e 65 0a 0a 09 23 20 43  reak..done...# C
1680: 72 65 61 74 65 20 70 6b 67 49 6e 64 65 78 20 69  reate pkgIndex i
1690: 66 20 6e 65 65 64 65 64 0a 09 69 66 20 5b 20 21  f needed..if [ !
16a0: 20 2d 65 20 22 24 7b 49 4e 53 54 44 49 52 7d 2f   -e "${INSTDIR}/
16b0: 6c 69 62 2f 74 6c 73 24 7b 54 4c 53 56 45 52 53  lib/tls${TLSVERS
16c0: 7d 2f 70 6b 67 49 6e 64 65 78 2e 74 63 6c 22 20  }/pkgIndex.tcl" 
16d0: 5d 3b 20 74 68 65 6e 0a 09 09 63 61 74 20 3c 3c  ]; then...cat <<
16e0: 20 5f 45 4f 46 5f 20 3e 20 22 24 7b 49 4e 53 54   _EOF_ > "${INST
16f0: 44 49 52 7d 2f 6c 69 62 2f 74 6c 73 24 7b 54 4c  DIR}/lib/tls${TL
1700: 53 56 45 52 53 7d 2f 70 6b 67 49 6e 64 65 78 2e  SVERS}/pkgIndex.
1710: 74 63 6c 22 0a 70 61 63 6b 61 67 65 20 69 66 6e  tcl".package ifn
1720: 65 65 64 65 64 20 74 6c 73 20 24 7b 54 4c 53 56  eeded tls ${TLSV
1730: 45 52 53 7d 20 5c 0a 20 20 20 20 22 5b 6c 69 73  ERS} \.    "[lis
1740: 74 20 73 6f 75 72 63 65 20 5b 66 69 6c 65 20 6a  t source [file j
1750: 6f 69 6e 20 5c 24 64 69 72 20 74 6c 73 2e 74 63  oin \$dir tls.tc
1760: 6c 5d 5d 20 3b 20 5c 0a 20 20 20 20 20 5b 6c 69  l]] ; \.     [li
1770: 73 74 20 6c 6f 61 64 20 7b 7d 20 74 6c 73 5d 22  st load {} tls]"
1780: 0a 5f 45 4f 46 5f 0a 09 66 69 0a 0a 09 23 20 44  ._EOF_..fi...# D
1790: 65 74 65 72 6d 69 6e 65 20 6e 61 6d 65 20 6f 66  etermine name of
17a0: 20 73 74 61 74 69 63 20 6f 62 6a 65 63 74 0a 09   static object..
17b0: 4c 49 4e 4b 41 44 44 46 49 4c 45 3d 22 24 28 66  LINKADDFILE="$(f
17c0: 69 6e 64 20 22 24 7b 49 4e 53 54 44 49 52 7d 22  ind "${INSTDIR}"
17d0: 20 2d 6e 61 6d 65 20 27 2a 2e 61 27 20 7c 20 68   -name '*.a' | h
17e0: 65 61 64 20 2d 6e 20 31 29 22 0a 09 69 66 20 5b  ead -n 1)"..if [
17f0: 20 2d 6e 20 22 24 7b 4c 49 4e 4b 41 44 44 46 49   -n "${LINKADDFI
1800: 4c 45 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 09 4c  LE}" ]; then...L
1810: 49 4e 4b 41 44 44 46 49 4c 45 3d 22 24 7b 4c 49  INKADDFILE="${LI
1820: 4e 4b 41 44 44 46 49 4c 45 7d 2e 6c 69 6e 6b 61  NKADDFILE}.linka
1830: 64 64 22 0a 0a 09 09 23 23 20 58 58 58 3a 20 54  dd"....## XXX: T
1840: 4f 44 4f 3a 20 44 65 74 65 72 6d 69 6e 65 20 77  ODO: Determine w
1850: 68 61 74 20 77 65 20 61 63 74 75 61 6c 6c 79 20  hat we actually 
1860: 6e 65 65 64 20 74 6f 20 6c 69 6e 6b 20 61 67 61  need to link aga
1870: 69 6e 73 74 0a 09 09 69 66 20 5b 20 2d 7a 20 22  inst...if [ -z "
1880: 24 7b 61 64 64 6c 69 62 73 7d 22 20 5d 3b 20 74  ${addlibs}" ]; t
1890: 68 65 6e 0a 09 09 09 69 66 20 5b 20 22 24 7b 4b  hen....if [ "${K
18a0: 43 5f 54 4c 53 5f 4c 49 4e 4b 53 53 4c 53 54 41  C_TLS_LINKSSLSTA
18b0: 54 49 43 7d 22 20 3d 20 27 31 27 20 5d 3b 20 74  TIC}" = '1' ]; t
18c0: 68 65 6e 0a 09 09 09 09 61 64 64 6c 69 62 73 3d  hen.....addlibs=
18d0: 22 24 28 22 24 7b 50 4b 47 5f 43 4f 4e 46 49 47  "$("${PKG_CONFIG
18e0: 3a 2d 70 6b 67 2d 63 6f 6e 66 69 67 7d 22 20 6c  :-pkg-config}" l
18f0: 69 62 73 73 6c 20 6c 69 62 63 72 79 70 74 6f 20  ibssl libcrypto 
1900: 2d 2d 6c 69 62 73 20 2d 2d 73 74 61 74 69 63 29  --libs --static)
1910: 22 0a 09 09 09 65 6c 73 65 0a 09 09 09 09 61 64  "....else.....ad
1920: 64 6c 69 62 73 3d 22 24 28 22 24 7b 50 4b 47 5f  dlibs="$("${PKG_
1930: 43 4f 4e 46 49 47 3a 2d 70 6b 67 2d 63 6f 6e 66  CONFIG:-pkg-conf
1940: 69 67 7d 22 20 6c 69 62 73 73 6c 20 6c 69 62 63  ig}" libssl libc
1950: 72 79 70 74 6f 20 2d 2d 6c 69 62 73 29 22 0a 09  rypto --libs)"..
1960: 09 09 66 69 0a 09 09 66 69 0a 0a 09 09 69 66 20  ..fi...fi....if 
1970: 5b 20 2d 7a 20 22 24 7b 61 64 64 6c 69 62 73 7d  [ -z "${addlibs}
1980: 22 20 5d 3b 20 74 68 65 6e 0a 09 09 09 61 64 64  " ]; then....add
1990: 6c 69 62 73 3d 22 2d 4c 24 7b 53 53 4c 5f 4c 49  libs="-L${SSL_LI
19a0: 42 5f 44 49 52 3a 2d 2f 6c 69 62 7d 20 2d 6c 73  B_DIR:-/lib} -ls
19b0: 73 6c 20 2d 6c 63 72 79 70 74 6f 22 0a 09 09 09  sl -lcrypto"....
19c0: 61 64 64 6c 69 62 73 5f 73 74 61 74 69 63 4f 6e  addlibs_staticOn
19d0: 6c 79 3d 22 22 0a 09 09 66 69 0a 0a 09 09 61 64  ly=""...fi....ad
19e0: 64 6c 69 62 73 3d 22 24 7b 61 64 64 6c 69 62 73  dlibs="${addlibs
19f0: 7d 20 24 7b 4b 43 5f 54 4c 53 5f 4c 49 4e 4b 41  } ${KC_TLS_LINKA
1a00: 44 44 7d 22 0a 0a 09 09 69 66 20 5b 20 22 24 7b  DD}"....if [ "${
1a10: 4b 43 5f 54 4c 53 5f 4c 49 4e 4b 53 53 4c 53 54  KC_TLS_LINKSSLST
1a20: 41 54 49 43 7d 22 20 3d 20 27 31 27 20 5d 3b 20  ATIC}" = '1' ]; 
1a30: 74 68 65 6e 0a 09 09 09 65 63 68 6f 20 22 2d 57  then....echo "-W
1a40: 6c 2c 2d 42 73 74 61 74 69 63 20 24 7b 61 64 64  l,-Bstatic ${add
1a50: 6c 69 62 73 7d 20 24 7b 61 64 64 6c 69 62 73 5f  libs} ${addlibs_
1a60: 73 74 61 74 69 63 4f 6e 6c 79 7d 20 2d 57 6c 2c  staticOnly} -Wl,
1a70: 2d 42 64 79 6e 61 6d 69 63 22 0a 09 09 65 6c 73  -Bdynamic"...els
1a80: 65 0a 09 09 09 65 63 68 6f 20 22 24 7b 61 64 64  e....echo "${add
1a90: 6c 69 62 73 7d 22 0a 09 09 66 69 20 3e 20 22 24  libs}"...fi > "$
1aa0: 7b 4c 49 4e 4b 41 44 44 46 49 4c 45 7d 22 0a 09  {LINKADDFILE}"..
1ab0: 66 69 0a 0a 09 23 20 49 6e 73 74 61 6c 6c 20 66  fi...# Install f
1ac0: 69 6c 65 73 20 6e 65 65 64 65 64 20 62 79 20 69  iles needed by i
1ad0: 6e 73 74 61 6c 6c 61 74 69 6f 6e 0a 09 63 70 20  nstallation..cp 
1ae0: 2d 72 20 22 24 7b 49 4e 53 54 44 49 52 7d 2f 6c  -r "${INSTDIR}/l
1af0: 69 62 22 20 22 24 7b 4f 55 54 44 49 52 7d 22 20  ib" "${OUTDIR}" 
1b00: 7c 7c 20 65 78 69 74 20 31 0a 09 66 69 6e 64 20  || exit 1..find 
1b10: 22 24 7b 4f 55 54 44 49 52 7d 22 20 2d 6e 61 6d  "${OUTDIR}" -nam
1b20: 65 20 27 2a 2e 61 27 20 2d 74 79 70 65 20 66 20  e '*.a' -type f 
1b30: 7c 20 78 61 72 67 73 20 2d 6e 20 31 20 72 6d 20  | xargs -n 1 rm 
1b40: 2d 66 20 2d 2d 0a 0a 09 65 78 69 74 20 30 0a 29  -f --...exit 0.)
1b50: 20 7c 7c 20 65 78 69 74 20 31 0a 0a 65 78 69 74   || exit 1..exit
1b60: 20 30 0a                                          0.